package de.markant.anwendkart.client;

import org.jboss.resteasy.client.ProxyFactory;
import org.jboss.resteasy.client.exception.ResteasyIOException;
import org.jboss.resteasy.client.jaxrs.ResteasyClientBuilder;
import org.junit.Test;

public class ClientRequestTest {

	/**
	 * The Serialization of the MultiPart calls works with the old API. 
	 */
	@Test(expected=ResteasyIOException.class)	// ResteasyIOException because of bogus url
	public void testOldFactory() {
		ApiService apiService = ProxyFactory.create(ApiService.class, "http://example.com");
		tryCall(apiService);
	}

	/**
	 * ... here it doesn't work 
	 */
	@Test(expected=ResteasyIOException.class)	// ResteasyIOException because of bogus url
	public void testNewBuilder() {
		ApiService apiService = new ResteasyClientBuilder().build().target("http://example.com").proxy(ApiService.class);
		tryCall(apiService);
	}

	private void tryCall(ApiService apiService) {
		Attachment attachment = new Attachment();
		attachment.setData("foo".getBytes());
		
		apiService.postAttachment(attachment, "some-key");
	}

}